"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.izanamiReload = izanamiReload;
exports.register = register;
exports.registerFetch = registerFetch;
exports.unregister = unregister;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var izanamiFetchs = {};
var izanamiListeners = {};

function izanamiReload(id) {
  var izanamiFetch = izanamiFetchs[id];

  if (izanamiFetch) {
    console.debug("Fetching for id ", id);
    return izanamiFetch().then(function (r) {
      return r.json();
    }).then(function (data) {
      var listeners = izanamiListeners[id] || [];
      listeners.forEach(function (l) {
        try {
          l(data);
        } catch (err) {
          console.error(err);
        }
      });
    });
  }
}

function registerFetch(id, fetchMethod) {
  izanamiFetchs = _objectSpread(_objectSpread({}, izanamiFetchs), {}, _defineProperty({}, id, fetchMethod));
}

function register(id, callback) {
  var listeners = izanamiListeners[id] || [];
  var index = listeners.indexOf(callback);

  if (index > -1) {
    listeners.splice(index, 1);
  }

  listeners.push(callback);
  izanamiListeners = _objectSpread(_objectSpread({}, izanamiListeners), {}, _defineProperty({}, id, listeners));
}

function unregister(path, callback) {
  if (callback && path) {
    var listeners = izanamiListeners[path] || [];
    var index = listeners.indexOf(callback);

    if (index > -1) {
      listeners.splice(index, 1);
      izanamiListeners = _objectSpread(_objectSpread({}, izanamiListeners), {}, _defineProperty({}, path, listeners));
    }
  } else if (path) {
    delete izanamiListeners[path];
  }
}