"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Pending = exports.FeatureProvider = exports.Feature = exports.Enabled = exports.Disabled = void 0;

require("es6-shim");

require("whatwg-fetch");

var _esSymbol = _interopRequireDefault(require("es-symbol"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = require("prop-types");

var _deepEqual = _interopRequireDefault(require("deep-equal"));

var _deepmerge = _interopRequireDefault(require("deepmerge"));

var _isFunction = _interopRequireDefault(require("lodash/isFunction"));

var _isEmpty = _interopRequireDefault(require("lodash/isEmpty"));

require("@ungap/global-this");

var Api = _interopRequireWildcard(require("./api"));

var _debug = _interopRequireDefault(require("./debug"));

var _util = require("./util");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

if (!globalThis.Symbol) {
  globalThis.Symbol = _esSymbol["default"];
}

var Enabled = /*#__PURE__*/function (_Component) {
  _inherits(Enabled, _Component);

  var _super = _createSuper(Enabled);

  function Enabled() {
    _classCallCheck(this, Enabled);

    return _super.apply(this, arguments);
  }

  _createClass(Enabled, [{
    key: "render",
    value: function render() {
      return this.props.children;
    }
  }]);

  return Enabled;
}(_react.Component);

exports.Enabled = Enabled;

var Disabled = /*#__PURE__*/function (_Component2) {
  _inherits(Disabled, _Component2);

  var _super2 = _createSuper(Disabled);

  function Disabled() {
    _classCallCheck(this, Disabled);

    return _super2.apply(this, arguments);
  }

  _createClass(Disabled, [{
    key: "render",
    value: function render() {
      return this.props.children;
    }
  }]);

  return Disabled;
}(_react.Component);

exports.Disabled = Disabled;

var Pending = /*#__PURE__*/function (_Component3) {
  _inherits(Pending, _Component3);

  var _super3 = _createSuper(Pending);

  function Pending() {
    _classCallCheck(this, Pending);

    return _super3.apply(this, arguments);
  }

  _createClass(Pending, [{
    key: "render",
    value: function render() {
      return this.props.children;
    }
  }]);

  return Pending;
}(_react.Component);

exports.Pending = Pending;

var Feature = /*#__PURE__*/function (_Component4) {
  _inherits(Feature, _Component4);

  var _super4 = _createSuper(Feature);

  function Feature() {
    var _this;

    _classCallCheck(this, Feature);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super4.call.apply(_super4, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "state", {
      features: {},
      mergedFeatures: {},
      isFetchPending: false
    });

    _defineProperty(_assertThisInitialized(_this), "onContextChange", function (_ref) {
      var __mergedFeatures = _ref.__mergedFeatures,
          __id = _ref.__id,
          __debug = _ref.__debug,
          __isFetchPending = _ref.__isFetchPending;

      if (__id && _this.state.id !== __id) {
        _this.setState({
          id: __id,
          debug: __debug,
          mergedFeatures: __mergedFeatures,
          isFetchPending: __isFetchPending
        });

        if (__debug) console.log('[Features] Registering to api for ', __id);
        Api.register(__id, _this.onFeaturesChanged);
      } else {
        _this.setState({
          debug: __debug,
          mergedFeatures: __mergedFeatures,
          isFetchPending: __isFetchPending
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "onFeaturesChanged", function (_ref2) {
      var features = _ref2.features;

      if (!(0, _deepEqual["default"])(_this.state.features, features)) {
        _this.setState({
          features: features
        });
      }
    });

    return _this;
  }

  _createClass(Feature, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.context.__subscribeToFeatureContext(this.onContextChange);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var id = this.state.id;

      if (id) {
        Api.unregister(id, this.onFeaturesChanged);
      }

      this.context.__unsubscribeToFeatureContext(this.onContextChange);
    }
  }, {
    key: "render",
    value: function render() {
      var children = this.props.children;
      var features = (0, _deepmerge["default"])(this.state.mergedFeatures, this.state.features);
      var arrayPath = (0, _util.getCleanedArrayPath)(this.props.path);
      var isActive = (0, _util.getIsActive)(features, arrayPath);
      var path = (0, _util.arrayPathToString)(arrayPath);
      var childrenArray = Array.isArray(children) ? children : [children];
      var enabledChildren = childrenArray.filter(function (c) {
        return c && c.type.toString() === Enabled.toString();
      });
      var disabledChildren = childrenArray.filter(function (c) {
        return c && c.type.toString() === Disabled.toString();
      });
      var pendingChildren = childrenArray.filter(function (c) {
        return c && c.type.toString() === Pending.toString();
      });
      var debug = !!this.state.debug || this.props.debug;

      if (this.props.render && (0, _isFunction["default"])(this.props.render)) {
        if (debug) {
          return /*#__PURE__*/_react["default"].createElement(_debug["default"], {
            isActive: isActive,
            path: path
          }, this.props.render(isActive));
        } else {
          return this.props.render(isActive);
        }
      }

      if (this.state.isFetchPending && !(0, _isEmpty["default"])(pendingChildren)) {
        if (debug) {
          console.log('[Features] IzanamiProvider fetchFrom request is pending, rendering first <Pending /> component');
          return /*#__PURE__*/_react["default"].createElement(_debug["default"], {
            isActive: isActive,
            path: path
          }, pendingChildren[0]);
        }

        return pendingChildren[0];
      } else if (isActive && (enabledChildren.length > 0 || disabledChildren.length > 0)) {
        if (debug) console.log("[Features] feature '".concat(path, "' is enabled, rendering first <Enabled /> component"));

        if (debug) {
          return /*#__PURE__*/_react["default"].createElement(_debug["default"], {
            isActive: isActive,
            path: path
          }, enabledChildren[0]);
        }

        return enabledChildren[0];
      } else if (!isActive && (enabledChildren.length > 0 || disabledChildren.length > 0)) {
        if (debug) console.log("[Features] feature '".concat(path, "' is disabled, rendering first <Disabled /> component"));

        if (debug) {
          return /*#__PURE__*/_react["default"].createElement(_debug["default"], {
            isActive: isActive,
            path: path
          }, disabledChildren[0]);
        }

        return disabledChildren[0];
      } else if (isActive) {
        if (debug) console.log("[Features] feature '".concat(path, "' is enabled, rendering first child"));

        if (childrenArray.length > 1) {
          console.warn('You have to provide only one child to <Feature /> unless it\'s <Enabled /> and <Disabled /> used together.');
        }

        if (debug) {
          return /*#__PURE__*/_react["default"].createElement(_debug["default"], {
            isActive: isActive,
            path: path
          }, childrenArray[0]);
        }

        return childrenArray[0];
      } else {
        if (debug) console.log("[Features] feature '".concat(path, "' is disabled, rendering nothing"));

        if (debug) {
          return /*#__PURE__*/_react["default"].createElement(_debug["default"], {
            isActive: isActive,
            path: path
          });
        }

        return null;
      }
    }
  }]);

  return Feature;
}(_react.Component);

exports.Feature = Feature;

_defineProperty(Feature, "contextTypes", {
  __subscribeToFeatureContext: _propTypes.func,
  __unsubscribeToFeatureContext: _propTypes.func
});

_defineProperty(Feature, "propTypes", {
  path: (0, _propTypes.oneOfType)([_propTypes.string, (0, _propTypes.arrayOf)(_propTypes.string)]).isRequired,
  debug: _propTypes.bool
});

_defineProperty(Feature, "defaultProps", {
  debug: false
});

var FeatureProvider = /*#__PURE__*/function (_Component5) {
  _inherits(FeatureProvider, _Component5);

  var _super5 = _createSuper(FeatureProvider);

  function FeatureProvider() {
    var _this2;

    _classCallCheck(this, FeatureProvider);

    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    _this2 = _super5.call.apply(_super5, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this2), "callbacks", []);

    _defineProperty(_assertThisInitialized(_this2), "state", {
      __id: _this2.props.id,
      __features: _this2.props.features,
      __fallback: _this2.props.fallback,
      __debug: _this2.props.debug,
      __mergedFeatures: (0, _deepmerge["default"])(_this2.props.fallback, _this2.props.features),
      __isFetchPending: _this2.props.isFetchPending
    });

    _defineProperty(_assertThisInitialized(_this2), "registerCb", function (callback) {
      var index = _this2.callbacks.indexOf(callback);

      if (index === -1) {
        _this2.callbacks.push(callback);
      }
    });

    _defineProperty(_assertThisInitialized(_this2), "unregisterCb", function (callback) {
      var index = _this2.callbacks.indexOf(callback);

      if (index > -1) {
        _this2.callbacks.splice(index, 1);
      }
    });

    _defineProperty(_assertThisInitialized(_this2), "publish", function () {
      _this2.callbacks.forEach(function (cb) {
        cb(_objectSpread({}, _this2.state));
      });
    });

    return _this2;
  }

  _createClass(FeatureProvider, [{
    key: "getChildContext",
    value: function getChildContext() {
      var _this3 = this;

      return {
        __subscribeToFeatureContext: function __subscribeToFeatureContext(cb) {
          if (cb) {
            var context = _objectSpread({}, _this3.state);

            cb(context);

            _this3.registerCb(cb);
          }
        },
        __unsubscribeToFeatureContext: function __unsubscribeToFeatureContext(cb) {
          if (cb) {
            _this3.unregisterCb(cb);
          }
        }
      };
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (!(0, _deepEqual["default"])(nextProps.features, this.props.features)) {
        this.setState({
          __features: nextProps.features,
          __mergedFeatures: (0, _deepmerge["default"])(this.state.__fallback, nextProps.features)
        }, this.publish);
      }

      if (!(0, _deepEqual["default"])(nextProps.fallback, this.props.fallback)) {
        this.setState({
          __fallback: nextProps.fallback,
          __mergedFeatures: (0, _deepmerge["default"])(nextProps.fallback, this.state.__features)
        }, this.publish);
      }

      if (nextProps.debug !== this.props.debug) {
        this.setState({
          __debug: nextProps.debug
        }, this.publish);
      }

      if (nextProps.isFetchPending !== this.props.isFetchPending) {
        this.setState({
          __isFetchPending: nextProps.isFetchPending
        }, this.publish);
      }
    }
  }, {
    key: "render",
    value: function render() {
      return this.props.children || null;
    }
  }]);

  return FeatureProvider;
}(_react.Component);

exports.FeatureProvider = FeatureProvider;

_defineProperty(FeatureProvider, "childContextTypes", {
  __subscribeToFeatureContext: _propTypes.func,
  __unsubscribeToFeatureContext: _propTypes.func
});

_defineProperty(FeatureProvider, "propTypes", {
  features: _propTypes.object.isRequired,
  fallback: _propTypes.object,
  id: _propTypes.string,
  debug: _propTypes.bool
});

_defineProperty(FeatureProvider, "defaultProps", {
  fallback: {}
});