"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  IzanamiProvider: true,
  Api: true
};
exports.IzanamiProvider = exports.Api = void 0;

var _react = _interopRequireWildcard(require("react"));

var _features2 = require("./features");

Object.keys(_features2).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _features2[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _features2[key];
    }
  });
});

var _experiments2 = require("./experiments");

Object.keys(_experiments2).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _experiments2[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _experiments2[key];
    }
  });
});

var Api = _interopRequireWildcard(require("./api"));

var _Api = Api;
exports.Api = Api;

var _propTypes = require("prop-types");

var _isFunction = _interopRequireDefault(require("lodash/isFunction"));

var _isString = _interopRequireDefault(require("lodash/isString"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var IzanamiProvider = /*#__PURE__*/function (_Component) {
  _inherits(IzanamiProvider, _Component);

  var _super = _createSuper(IzanamiProvider);

  function IzanamiProvider(args) {
    var _this;

    _classCallCheck(this, IzanamiProvider);

    _this = _super.call(this, args);

    _defineProperty(_assertThisInitialized(_this), "state", {
      loading: false,
      fetched: {},
      isFetchPending: Boolean(_this.props.fetchFrom)
    });

    _defineProperty(_assertThisInitialized(_this), "id", function () {
      return _this.props.id ? _this.props.id : (0, _isFunction["default"])(_this.props.fetchFrom) ? _this.props.fetchFrom : "default";
    });

    _defineProperty(_assertThisInitialized(_this), "onDataLoaded", function (data) {
      _this.setState({
        loading: false,
        fetched: {
          features: data.features || _this.props.features,
          featuresFallback: data.featuresFallback || _this.props.featuresFallback,
          experiments: data.experiments || _this.props.experiments,
          experimentsFallback: data.experimentsFallback || _this.props.experimentsFallback,
          debug: data.debug || !!_this.props.debug
        }
      });
    });

    return _this;
  }

  _createClass(IzanamiProvider, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      if (this.props.fetchFrom) {
        var id = this.id();

        if (!id) {
          console.error("Id should not be null for IzanamiProvider");
          return;
        }

        this.setState({
          id: id
        });

        if ((0, _isFunction["default"])(this.props.fetchFrom)) {
          Api.registerFetch(id, this.props.fetchFrom);
        } else if ((0, _isString["default"])(this.props.fetchFrom)) {
          Api.registerFetch(id, function () {
            return fetch(_this2.props.fetchFrom, {
              method: 'GET',
              credentials: 'include',
              headers: _this2.props.fetchHeaders
            });
          });
        }

        Api.register(id, this.onDataLoaded);
        this.setState({
          loading: true
        });
        Api.izanamiReload(id, this.props.fetchHeaders)["finally"](function () {
          _this2.setState({
            isFetchPending: false
          });
        });
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.state.id) {
        Api.unregister(this.state.id, this.onDataLoaded);
      }
    }
  }, {
    key: "render",
    value: function render() {
      if (this.props.fetchFrom) {
        var _this$state$fetched = this.state.fetched,
            debug = _this$state$fetched.debug,
            features = _this$state$fetched.features,
            featuresFallback = _this$state$fetched.featuresFallback,
            experiments = _this$state$fetched.experiments,
            experimentsFallback = _this$state$fetched.experimentsFallback;
        var id = this.id();
        return /*#__PURE__*/_react["default"].createElement(_features2.FeatureProvider, {
          isFetchPending: this.state.isFetchPending,
          id: id,
          debug: debug,
          features: features || {},
          fallback: featuresFallback,
          fetchFrom: this.props.fetchFrom
        }, /*#__PURE__*/_react["default"].createElement(_experiments2.ExperimentsProvider, {
          id: id,
          debug: debug,
          experiments: experiments || {},
          experimentsFallback: experimentsFallback
        }, this.props.children));
      } else {
        var _this$props = this.props,
            _debug = _this$props.debug,
            _features = _this$props.features,
            _featuresFallback = _this$props.featuresFallback,
            _experiments = _this$props.experiments,
            _experimentsFallback = _this$props.experimentsFallback,
            children = _this$props.children;

        var _id = this.id();

        return /*#__PURE__*/_react["default"].createElement(_features2.FeatureProvider, {
          id: _id,
          debug: _debug,
          features: _features,
          fallback: _featuresFallback
        }, /*#__PURE__*/_react["default"].createElement(_experiments2.ExperimentsProvider, {
          id: _id,
          debug: _debug,
          experiments: _experiments,
          experimentsFallback: _experimentsFallback
        }, children));
      }
    }
  }]);

  return IzanamiProvider;
}(_react.Component);

exports.IzanamiProvider = IzanamiProvider;

_defineProperty(IzanamiProvider, "propTypes", {
  id: _propTypes.string,
  features: _propTypes.object,
  featuresFallback: _propTypes.object,
  experiments: _propTypes.object,
  experimentsFallback: _propTypes.object,
  debug: _propTypes.bool,
  fetchFrom: (0, _propTypes.oneOfType)([_propTypes.string, _propTypes.func]),
  fetchData: _propTypes.func,
  fetchHeaders: _propTypes.object,
  loading: _propTypes.func
});

_defineProperty(IzanamiProvider, "defaultProps", {
  featuresFallback: {},
  experimentsFallback: {},
  debug: false,
  fetchHeaders: {},
  id: "default",
  loading: function loading() {
    return null;
  }
});