"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getIsFeatureActive = exports.getIsActive = exports.getCleanedArrayPath = exports.cleanPath = exports.arrayPathToString = void 0;

var _get = _interopRequireDefault(require("lodash/get"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var getIsActive = function getIsActive(features, path) {
  return path.map(function (p) {
    return getIsFeatureActive(features, p);
  }).every(function (p) {
    return p;
  });
};

exports.getIsActive = getIsActive;

var getIsFeatureActive = function getIsFeatureActive(features, path) {
  var value = (0, _get["default"])(features, path) || {
    active: false
  };
  return value.active;
};

exports.getIsFeatureActive = getIsFeatureActive;

var getCleanedArrayPath = function getCleanedArrayPath(path) {
  if (Array.isArray(path)) {
    return path.map(function (p) {
      return cleanPath(p);
    });
  } else {
    return [cleanPath(path)];
  }
};

exports.getCleanedArrayPath = getCleanedArrayPath;

var cleanPath = function cleanPath(path) {
  return path.replace(/:/g, '.');
};

exports.cleanPath = cleanPath;

var arrayPathToString = function arrayPathToString(arrayPath) {
  return "[" + arrayPath.join(" & ") + "]";
};

exports.arrayPathToString = arrayPathToString;